package com.jiuqi.util.json;

/* loaded from: com_jiuqi_util_json.jar:com/jiuqi/util/json/JSONTokener.class */
public class JSONTokener {
    private int myIndex = 0;
    private String mySource;

    public JSONTokener(String s) {
        this.mySource = s;
    }

    public void back() {
        if (this.myIndex > 0) {
            this.myIndex--;
        }
    }

    public static int dehexchar(char c) {
        if (c >= '0' && c <= '9') {
            return c - '0';
        }
        if (c >= 'A' && c <= 'F') {
            return c - '7';
        }
        if (c >= 'a' && c <= 'f') {
            return c - 'W';
        }
        return -1;
    }

    public boolean more() {
        return this.myIndex < this.mySource.length();
    }

    public char next() {
        if (more()) {
            char c = this.mySource.charAt(this.myIndex);
            this.myIndex++;
            return c;
        }
        return (char) 0;
    }

    public char next(char c) throws JSONException {
        char n = next();
        if (n != c) {
            throw syntaxError("Expected '" + c + "' and instead saw '" + n + "'");
        }
        return n;
    }

    public String next(int n) throws JSONException {
        int i = this.myIndex;
        int j = i + n;
        if (j >= this.mySource.length()) {
            throw syntaxError("Substring bounds error");
        }
        this.myIndex += n;
        return this.mySource.substring(i, j);
    }

    /* JADX WARN: Code restructure failed: missing block: B:13:0x009c, code lost:
    
        return r0;
     */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
        To view partially-correct code enable 'Show inconsistent code' option in preferences
    */
    public char nextClean() throws com.jiuqi.util.json.JSONException {
        /*
            r3 = this;
        L0:
            r0 = r3
            char r0 = r0.next()
            r4 = r0
            r0 = r4
            r1 = 47
            if (r0 != r1) goto L73
            r0 = r3
            char r0 = r0.next()
            switch(r0) {
                case 42: goto L40;
                case 47: goto L28;
                default: goto L69;
            }
        L28:
            r0 = r3
            char r0 = r0.next()
            r4 = r0
            r0 = r4
            r1 = 10
            if (r0 == r1) goto L0
            r0 = r4
            r1 = 13
            if (r0 == r1) goto L0
            r0 = r4
            if (r0 != 0) goto L28
            goto L0
        L40:
            r0 = r3
            char r0 = r0.next()
            r4 = r0
            r0 = r4
            if (r0 != 0) goto L50
            r0 = r3
            java.lang.String r1 = "Unclosed comment"
            com.jiuqi.util.json.JSONException r0 = r0.syntaxError(r1)
            throw r0
        L50:
            r0 = r4
            r1 = 42
            if (r0 != r1) goto L40
            r0 = r3
            char r0 = r0.next()
            r1 = 47
            if (r0 != r1) goto L62
            goto L0
        L62:
            r0 = r3
            r0.back()
            goto L40
        L69:
            r0 = r3
            r0.back()
            r0 = 47
            return r0
            goto L0
        L73:
            r0 = r4
            r1 = 35
            if (r0 != r1) goto L91
        L79:
            r0 = r3
            char r0 = r0.next()
            r4 = r0
            r0 = r4
            r1 = 10
            if (r0 == r1) goto L0
            r0 = r4
            r1 = 13
            if (r0 == r1) goto L0
            r0 = r4
            if (r0 != 0) goto L79
            goto L0
        L91:
            r0 = r4
            if (r0 == 0) goto L9b
            r0 = r4
            r1 = 32
            if (r0 <= r1) goto L0
        L9b:
            r0 = r4
            return r0
        */
        throw new UnsupportedOperationException("Method not decompiled: com.jiuqi.util.json.JSONTokener.nextClean():char");
    }

    public String nextString(char quote) throws JSONException {
        StringBuffer sb = new StringBuffer();
        while (true) {
            char c = next();
            switch (c) {
                case 0:
                case '\n':
                case '\r':
                    throw syntaxError("Unterminated string");
                case '\\':
                    char c2 = next();
                    switch (c2) {
                        case 'b':
                            sb.append('\b');
                            break;
                        case 'f':
                            sb.append('\f');
                            break;
                        case 'n':
                            sb.append('\n');
                            break;
                        case 'r':
                            sb.append('\r');
                            break;
                        case 't':
                            sb.append('\t');
                            break;
                        case 'u':
                            sb.append((char) Integer.parseInt(next(4), 16));
                            break;
                        case 'x':
                            sb.append((char) Integer.parseInt(next(2), 16));
                            break;
                        default:
                            sb.append(c2);
                            break;
                    }
                default:
                    if (c == quote) {
                        return sb.toString();
                    }
                    sb.append(c);
                    break;
            }
        }
    }

    public String nextTo(char d) {
        char c;
        StringBuffer sb = new StringBuffer();
        while (true) {
            c = next();
            if (c == d || c == 0 || c == '\n' || c == '\r') {
                break;
            }
            sb.append(c);
        }
        if (c != 0) {
            back();
        }
        return sb.toString().trim();
    }

    public String nextTo(String delimiters) {
        char c;
        StringBuffer sb = new StringBuffer();
        while (true) {
            c = next();
            if (delimiters.indexOf(c) >= 0 || c == 0 || c == '\n' || c == '\r') {
                break;
            }
            sb.append(c);
        }
        if (c != 0) {
            back();
        }
        return sb.toString().trim();
    }

    public Object nextValue() throws JSONException {
        char c = nextClean();
        switch (c) {
            case '\"':
            case '\'':
                return nextString(c);
            case '(':
            case '[':
                back();
                return new JSONArray(this);
            case '{':
                back();
                return new JSONObject(this);
            default:
                StringBuffer sb = new StringBuffer();
                while (c >= ' ' && ",:]}/\\\"[{;=#".indexOf(c) < 0) {
                    sb.append(c);
                    c = next();
                }
                back();
                String s = sb.toString().trim();
                if (s.equals("")) {
                    throw syntaxError("Missing value");
                }
                if (s.equalsIgnoreCase("true")) {
                    return Boolean.TRUE;
                }
                if (s.equalsIgnoreCase("false")) {
                    return Boolean.FALSE;
                }
                if (s.equalsIgnoreCase("null")) {
                    return JSONObject.NULL;
                }
                if ((c >= '0' && c <= '9') || c == '.' || c == '-' || c == '+') {
                    if (c == '0') {
                        if (s.length() > 2 && (s.charAt(1) == 'x' || s.charAt(1) == 'X')) {
                            try {
                                return new Integer(Integer.parseInt(s.substring(2), 16));
                            } catch (Exception unused) {
                            }
                        } else {
                            try {
                                return new Integer(Integer.parseInt(s, 8));
                            } catch (Exception unused2) {
                            }
                        }
                    }
                    try {
                        return new Integer(s);
                    } catch (Exception unused3) {
                        try {
                            return new Long(s);
                        } catch (Exception unused4) {
                            try {
                                return new Double(s);
                            } catch (Exception unused5) {
                                return s;
                            }
                        }
                    }
                }
                return s;
        }
    }

    public char skipTo(char to) {
        char c;
        int index = this.myIndex;
        do {
            c = next();
            if (c == 0) {
                this.myIndex = index;
                return c;
            }
        } while (c != to);
        back();
        return c;
    }

    public boolean skipPast(String to) {
        this.myIndex = this.mySource.indexOf(to, this.myIndex);
        if (this.myIndex < 0) {
            this.myIndex = this.mySource.length();
            return false;
        }
        this.myIndex += to.length();
        return true;
    }

    public JSONException syntaxError(String message) {
        return new JSONException(String.valueOf(message) + toString());
    }

    public String toString() {
        return " at character " + this.myIndex + " of " + this.mySource;
    }
}
